stages:
  - test
  - build
  - deploy

test_app:
  stage: test
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  image: python:3.8-alpine
  script:
    - apk update && apk add postgresql-dev gcc python3-dev musl-dev zlib-dev jpeg-dev graphviz-dev libpq
    - pip install --upgrade pip
    - python -m pip install -r requirements.txt
    - pytest
  tags:
    - backend-runner

build_push_app:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
    
  script:
    - |
      if [ "$CI_COMMIT_REF_NAME" = $CI_DEFAULT_BRANCH ]; then
        VERSION="latest"
      else \
        VERSION="$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"
      fi
    - echo $VERSION
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 -w 0)\"}}}" > /kaniko/.docker/config.json
    - >-
      /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:$VERSION"
  only:
    - master
    - develop
  tags:
    - backend-runner

deploy_app:
  stage: deploy
  image: alpine/helm:3.9.4
  script:
    - echo "Deploy a review app"
    - |
      if [ "$CI_COMMIT_REF_NAME" = $CI_DEFAULT_BRANCH ]; then
        VERSION="latest" \
        ENVIROMENT="prod"
      else \
        VERSION="$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA" \
        ENVIROMENT="dev"
      fi
    - echo $VERSION
    - echo $ENVIROMENT
    - helm version
    - helm upgrade --install -n $ENVIROMENT backend-app-$ENVIROMENT backend-app/ --values backend-app/values.yaml --set image.tag=$VERSION --debug --wait
  environment:
    name: review/$CI_COMMIT_REF_SLUG
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
    - if: $CI_COMMIT_BRANCH == "develop"
  tags:
    - backend-runner